# REST

### Overview

The internal Clarity LIMS API (eg, <https://example.claritylims.com/clarity/api>) is the API used to deliver the Clarity LIMS web interface. This interface is not typically meant for public consumption. However, some customers use it for troubleshooting and to mitigate system issues.

#### Preventing CSRF Attacks

As of Clarity LIMS v5.1, access to the internal Clarity LIMS API changed to enhance security and prevent Cross Site Request Forgery (CSRF) attacks. Two new HTTP headers must now be present when issuing PUT, POST, DELETE, and PATCH requests:

* **Origin**—This header must be set to the scheme and authority of the server being accessed (eg, https\:// example.claritylims.com).
* **X-Requested-With**—This header must be set to XMLHttpRequest.

The attached cURL, Python, and Java examples demonstrate how to authenticate and issue internal API requests. These examples assume a Clarity LIMS server at <https://example.claritylims.com>.

csrf headers.sh:

{% file src="/files/w0XVQOVlZHYvfLfUYCs0" %}

csrf headers.py:

{% file src="/files/kYOJp5yceaql07R9wxVe" %}

csrf headers.java:

{% file src="/files/9l3Mpv7sHymfPGboNHj2" %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://help.claritylims.illumina.com/api-and-database/api-docs/rest.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
